com.google.gwt.dom.builder.client

## Class DomBuilderImpl

- java.lang.Object
- - com.google.gwt.dom.builder.shared.ElementBuilderImpl
  - - com.google.gwt.dom.builder.client.DomBuilderImpl

    class DomBuilderImpl
    extends ElementBuilderImpl

Implementation of methods in `ElementBuilderBase` used to render Elements using DOM manipulation.

### Property Summary

All Methods Instance Methods Concrete Methods
`(package private) Style` `assertCanAddStyle` Assert that the builder is in a state where a style property can be added.

### Constructor Summary

Constructors
Constructor and Description
`DomBuilderImpl()`

### Method Summary

All Methods Instance Methods Concrete Methods
`(package private) Element` `assertCanAddAttribute()` Assert that the builder is in a state where an attribute can be added.
`(package private) Style` `assertCanAddStyleProperty()` Assert that the builder is in a state where a style property can be added.
`protected void` `doCloseStartTagImpl()` Close the start tag.
`protected void` `doCloseStyleAttributeImpl()` Close the style attribute.
`protected void` `doEndStartTagImpl()` Self-close the start tag.
`protected void` `doEndTagImpl(java.lang.String tagName)` End the specified tag.
`protected Element` `doFinishImpl()` Return the build element.
`protected void` `doHtmlImpl(SafeHtml html)` Set the specified html as the inner HTML of the current element.
`protected void` `doOpenStyleImpl()` Open the style attribute.
`protected void` `doTextImpl(java.lang.String text)` Set the specified text as the inner text of the current element.
`(package private) Element` `getCurrentElement()` Get the element current being built.
`protected void` `lockCurrentElement()` Lock the current element, preventing any additional changes to it.
`DomAnchorBuilder` `startAnchor()`
`DomAreaBuilder` `startArea()`
`DomAudioBuilder` `startAudio()`
`DomBaseBuilder` `startBase()`
`DomQuoteBuilder` `startBlockQuote()`
`DomBodyBuilder` `startBody()`
`DomBRBuilder` `startBR()`
`InputBuilder` `startButtonInput()`
`DomCanvasBuilder` `startCanvas()`
`InputBuilder` `startCheckboxInput()`
`DomTableColBuilder` `startCol()`
`DomTableColBuilder` `startColGroup()`
`DomDivBuilder` `startDiv()`
`DomDListBuilder` `startDList()`
`DomFieldSetBuilder` `startFieldSet()`
`InputBuilder` `startFileInput()`
`DomFormBuilder` `startForm()`
`DomFrameBuilder` `startFrame()`
`DomFrameSetBuilder` `startFrameSet()`
`DomHeadingBuilder` `startH1()`
`DomHeadingBuilder` `startH2()`
`DomHeadingBuilder` `startH3()`
`DomHeadingBuilder` `startH4()`
`DomHeadingBuilder` `startH5()`
`DomHeadingBuilder` `startH6()`
`DomHeadBuilder` `startHead()`
`InputBuilder` `startHiddenInput()`
`DomHRBuilder` `startHR()`
`DomIFrameBuilder` `startIFrame()`
`DomImageBuilder` `startImage()`
`InputBuilder` `startImageInput()`
`DomInputBuilder` `startInput(InputElement input)` Start an input using the specified InputElement.
`DomLabelBuilder` `startLabel()`
`DomLegendBuilder` `startLegend()`
`DomLIBuilder` `startLI()`
`DomLinkBuilder` `startLink()`
`DomMapBuilder` `startMap()`
`DomMetaBuilder` `startMeta()`
`DomOListBuilder` `startOList()`
`DomOptGroupBuilder` `startOptGroup()`
`DomOptionBuilder` `startOption()`
`DomParagraphBuilder` `startParagraph()`
`DomParamBuilder` `startParam()`
`InputBuilder` `startPasswordInput()`
`DomPreBuilder` `startPre()`
`DomButtonBuilder` `startPushButton()`
`DomQuoteBuilder` `startQuote()`
`InputBuilder` `startRadioInput(java.lang.String name)`
`DomButtonBuilder` `startResetButton()`
`InputBuilder` `startResetInput()`
`DomScriptBuilder` `startScript()`
`DomSelectBuilder` `startSelect()`
`DomSourceBuilder` `startSource()`
`DomSpanBuilder` `startSpan()`
`DomStyleBuilder` `startStyle()`
`DomButtonBuilder` `startSubmitButton()`
`InputBuilder` `startSubmitInput()`
`DomTableBuilder` `startTable()`
`DomTableCaptionBuilder` `startTableCaption()`
`DomTableSectionBuilder` `startTBody()`
`DomTableCellBuilder` `startTD()`
`DomTextAreaBuilder` `startTextArea()`
`(package private) InputBuilder` `startTextInput()`
`DomTableSectionBuilder` `startTFoot()`
`DomTableCellBuilder` `startTH()`
`DomTableSectionBuilder` `startTHead()`
`DomTableRowBuilder` `startTR()`
`DomUListBuilder` `startUList()`
`DomVideoBuilder` `startVideo()`
`StylesBuilder` `style()` Get the `StylesBuilder` used to add style properties to the current element.
`DomElementBuilder` `trustedStart(java.lang.String tagName)`

### Methods inherited from class com.google.gwt.dom.builder.shared.ElementBuilderImpl

`assertCanAddAttributeImpl, assertCanAddStylePropertyImpl, assertValidTagName, end, end, endAllTags, endStyle, finish, getDepth, html, onStart, text`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Property Detail

#### assertCanAddStyle

    Style assertCanAddStyleProperty

Assert that the builder is in a state where a style property can be added.

### Constructor Detail

#### DomBuilderImpl

    DomBuilderImpl()

### Method Detail

#### startAnchor

    public DomAnchorBuilder startAnchor()

#### startArea

    public DomAreaBuilder startArea()

#### startAudio

    public DomAudioBuilder startAudio()

#### startBase

    public DomBaseBuilder startBase()

#### startBlockQuote

    public DomQuoteBuilder startBlockQuote()

#### startBody

    public DomBodyBuilder startBody()

#### startBR

    public DomBRBuilder startBR()

#### startButtonInput

    public InputBuilder startButtonInput()

#### startCanvas

    public DomCanvasBuilder startCanvas()

#### startCheckboxInput

    public InputBuilder startCheckboxInput()

#### startCol

    public DomTableColBuilder startCol()

#### startColGroup

    public DomTableColBuilder startColGroup()

#### startDiv

    public DomDivBuilder startDiv()

#### startDList

    public DomDListBuilder startDList()

#### startFieldSet

    public DomFieldSetBuilder startFieldSet()

#### startFileInput

    public InputBuilder startFileInput()

#### startForm

    public DomFormBuilder startForm()

#### startFrame

    public DomFrameBuilder startFrame()

#### startFrameSet

    public DomFrameSetBuilder startFrameSet()

#### startH1

    public DomHeadingBuilder startH1()

#### startH2

    public DomHeadingBuilder startH2()

#### startH3

    public DomHeadingBuilder startH3()

#### startH4

    public DomHeadingBuilder startH4()

#### startH5

    public DomHeadingBuilder startH5()

#### startH6

    public DomHeadingBuilder startH6()

#### startHead

    public DomHeadBuilder startHead()

#### startHiddenInput

    public InputBuilder startHiddenInput()

#### startHR

    public DomHRBuilder startHR()

#### startIFrame

    public DomIFrameBuilder startIFrame()

#### startImage

    public DomImageBuilder startImage()

#### startImageInput

    public InputBuilder startImageInput()

#### startInput

    public DomInputBuilder startInput(InputElement input)

Start an input using the specified InputElement.

#### startLabel

    public DomLabelBuilder startLabel()

#### startLegend

    public DomLegendBuilder startLegend()

#### startLI

    public DomLIBuilder startLI()

#### startLink

    public DomLinkBuilder startLink()

#### startMap

    public DomMapBuilder startMap()

#### startMeta

    public DomMetaBuilder startMeta()

#### startOList

    public DomOListBuilder startOList()

#### startOptGroup

    public DomOptGroupBuilder startOptGroup()

#### startOption

    public DomOptionBuilder startOption()

#### startParagraph

    public DomParagraphBuilder startParagraph()

#### startParam

    public DomParamBuilder startParam()

#### startPasswordInput

    public InputBuilder startPasswordInput()

#### startPre

    public DomPreBuilder startPre()

#### startPushButton

    public DomButtonBuilder startPushButton()

#### startQuote

    public DomQuoteBuilder startQuote()

#### startRadioInput

    public InputBuilder startRadioInput(java.lang.String name)

#### startResetButton

    public DomButtonBuilder startResetButton()

#### startResetInput

    public InputBuilder startResetInput()

#### startScript

    public DomScriptBuilder startScript()

#### startSelect

    public DomSelectBuilder startSelect()

#### startSource

    public DomSourceBuilder startSource()

#### startSpan

    public DomSpanBuilder startSpan()

#### startStyle

    public DomStyleBuilder startStyle()

#### startSubmitButton

    public DomButtonBuilder startSubmitButton()

#### startSubmitInput

    public InputBuilder startSubmitInput()

#### startTable

    public DomTableBuilder startTable()

#### startTableCaption

    public DomTableCaptionBuilder startTableCaption()

#### startTBody

    public DomTableSectionBuilder startTBody()

#### startTD

    public DomTableCellBuilder startTD()

#### startTextArea

    public DomTextAreaBuilder startTextArea()

#### startTFoot

    public DomTableSectionBuilder startTFoot()

#### startTH

    public DomTableCellBuilder startTH()

#### startTHead

    public DomTableSectionBuilder startTHead()

#### startTR

    public DomTableRowBuilder startTR()

#### startUList

    public DomUListBuilder startUList()

#### startVideo

    public DomVideoBuilder startVideo()

#### style

    public StylesBuilder style()

Description copied from class: `ElementBuilderImpl`
Get the `StylesBuilder` used to add style properties to the current element.

Specified by:
  `style` in class `ElementBuilderImpl`
Returns:
  a `StylesBuilder`

#### trustedStart

    public DomElementBuilder trustedStart(java.lang.String tagName)

#### doCloseStartTagImpl

    protected void doCloseStartTagImpl()

Description copied from class: `ElementBuilderImpl`
Close the start tag.

Specified by:
  `doCloseStartTagImpl` in class `ElementBuilderImpl`

#### doCloseStyleAttributeImpl

    protected void doCloseStyleAttributeImpl()

Description copied from class: `ElementBuilderImpl`
Close the style attribute.

Specified by:
  `doCloseStyleAttributeImpl` in class `ElementBuilderImpl`

#### doEndStartTagImpl

    protected void doEndStartTagImpl()

Description copied from class: `ElementBuilderImpl`
Self-close the start tag. This method is called for elements that forbid the end tag.

Specified by:
  `doEndStartTagImpl` in class `ElementBuilderImpl`

#### doEndTagImpl

    protected void doEndTagImpl(java.lang.String tagName)

Description copied from class: `ElementBuilderImpl`
End the specified tag.

Specified by:
  `doEndTagImpl` in class `ElementBuilderImpl`
Parameters:
  `tagName` - the name of the tag to end

#### doFinishImpl

    protected Element doFinishImpl()

Description copied from class: `ElementBuilderImpl`
Return the build element.

Specified by:
  `doFinishImpl` in class `ElementBuilderImpl`
Returns:
  the element

#### doHtmlImpl

    protected void doHtmlImpl(SafeHtml html)

Description copied from class: `ElementBuilderImpl`
Set the specified html as the inner HTML of the current element.

Specified by:
  `doHtmlImpl` in class `ElementBuilderImpl`
Parameters:
  `html` - the HTML to set

#### doOpenStyleImpl

    protected void doOpenStyleImpl()

Description copied from class: `ElementBuilderImpl`
Open the style attribute.

Specified by:
  `doOpenStyleImpl` in class `ElementBuilderImpl`

#### doTextImpl

    protected void doTextImpl(java.lang.String text)

Description copied from class: `ElementBuilderImpl`
Set the specified text as the inner text of the current element.

Specified by:
  `doTextImpl` in class `ElementBuilderImpl`
Parameters:
  `text` - the text to set

#### lockCurrentElement

    protected void lockCurrentElement()

Description copied from class: `ElementBuilderImpl`
Lock the current element, preventing any additional changes to it. The only valid option is to call `ElementBuilderImpl.end()`.

Overrides:
  `lockCurrentElement` in class `ElementBuilderImpl`

#### assertCanAddAttribute

    Element assertCanAddAttribute()

Assert that the builder is in a state where an attribute can be added.

Returns:
  the element on which the attribute can be set

#### assertCanAddStyleProperty

    Style assertCanAddStyleProperty()

Assert that the builder is in a state where a style property can be added.

#### getCurrentElement

    Element getCurrentElement()

Get the element current being built.

#### startTextInput

    InputBuilder startTextInput()